Package org.apache.solr.client.solrj.io.stream

## Class TupleStream

- java.lang.Object
- - org.apache.solr.client.solrj.io.stream.TupleStream

All Implemented Interfaces:
  `Closeable`, `Serializable`, `AutoCloseable`, `MapSerializable`, `MapWriter`, `NavigableObject`

Direct Known Subclasses:
  `CalculatorStream`, `CartesianProductStream`, `CellStream`, `CloudSolrStream`, `CommitStream`, `ComplementStream`, `CsvStream`, `DaemonStream`, `DeepRandomStream`, `EchoStream`, `EvalStream`, `ExceptionStream`, `ExecutorStream`, `Facet2DStream`, `FacetStream`, `FeaturesSelectionStream`, `FetchStream`, `GatherNodesStream`, `GetStream`, `HashJoinStream`, `HashRollupStream`, `HavingStream`, `IntersectStream`, `JDBCStream`, `JoinStream`, `KnnStream`, `Lang.LocalInputStream`, `LetStream`, `ListStream`, `MergeStream`, `ModelStream`, `NoOpStream`, `NullStream`, `ParallelListStream`, `PlotStream`, `PriorityStream`, `PushBackStream`, `RandomFacadeStream`, `RandomStream`, `RankStream`, `ReducerStream`, `RollupStream`, `ScoreNodesStream`, `SearchFacadeStream`, `SearchStream`, `SelectStream`, `ShortestPathStream`, `SignificantTermsStream`, `SolrStream`, `SortStream`, `SqlStream`, `StatsStream`, `TextLogitStream`, `TextLogitStream.TermsStream`, `TimeSeriesStream`, `TupStream`, `UniqueStream`, `UpdateStream`, `ZplotStream`

    public abstract class TupleStream
    extends Object
    implements Closeable, Serializable, MapWriter

Since:
  5.1.0
See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `TupleStream.IgnoreException`

### Nested classes/interfaces inherited from interface org.apache.solr.common.MapWriter

`MapWriter.EntryWriter`

### Constructor Summary

Constructors
`TupleStream()`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`abstract List<TupleStream>` `children()`
`abstract void` `close()`
`int` `getCost()`
`static List<String>` `getShards​(String zkHost, String collection, StreamContext streamContext)`
`static List<String>` `getShards​(String zkHost, String collection, StreamContext streamContext, SolrParams requestParams)`
`UUID` `getStreamNodeId()`
`abstract StreamComparator` `getStreamSort()`
`abstract void` `open()`
`abstract Tuple` `read()`
`abstract void` `setStreamContext​(StreamContext context)`
`abstract Explanation` `toExplanation​(StreamFactory factory)`
`void` `writeMap​(MapWriter.EntryWriter ew)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.solr.common.MapWriter

`jsonStr, toMap`

### Methods inherited from interface org.apache.solr.common.NavigableObject

`_forEachEntry, _forEachEntry, _forEachEntry, _get, _get, _getStr, _getStr, _size`

### Constructor Detail

#### TupleStream

    public TupleStream()

### Method Detail

#### setStreamContext

    public abstract void setStreamContext​(StreamContext context)

#### children

    public abstract List<TupleStream> children()

#### open

    public abstract void open()
                       throws IOException

Throws:
  `IOException`

#### close

    public abstract void close()
                        throws IOException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Throws:
  `IOException`

#### read

    public abstract Tuple read()
                        throws IOException

Throws:
  `IOException`

#### getStreamSort

    public abstract StreamComparator getStreamSort()

#### toExplanation

    public abstract Explanation toExplanation​(StreamFactory factory)
                                       throws IOException

Throws:
  `IOException`

#### getCost

    public int getCost()

#### writeMap

    public void writeMap​(MapWriter.EntryWriter ew)
                  throws IOException

Specified by:
  `writeMap` in interface `MapWriter`
Throws:
  `IOException`

#### getStreamNodeId

    public UUID getStreamNodeId()

#### getShards

    public static List<String> getShards​(String zkHost,
                                         String collection,
                                         StreamContext streamContext)
                                  throws IOException

Throws:
  `IOException`

#### getShards

    public static List<String> getShards​(String zkHost,
                                         String collection,
                                         StreamContext streamContext,
                                         SolrParams requestParams)
                                  throws IOException

Throws:
  `IOException`